diff --git a/web/pgadmin/misc/cloud/utils/rds.py b/web/pgadmin/misc/cloud/utils/rds.py
new file mode 100644
index 000000000..bf81d17d4
--- /dev/null
+++ b/web/pgadmin/misc/cloud/utils/rds.py
@@ -0,0 +1,171 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+# AWS RDS PostgreSQL provider
+
+import boto3
+import pickle
+from flask import session
+from boto3.session import Session
+
+
+class RDS():
+    def __init__(self, access_key, secret_key, session_token=None,
+                 default_region='ap-south-1'):
+        self._clients = {}
+
+        self._access_key = access_key
+        self._secret_key = secret_key
+        self._session_token = session_token
+
+        self._default_region = default_region
+
+    ##########################################################################
+    # AWS Helper functions
+    ##########################################################################
+    def _get_aws_client(self, type):
+        """ Create/cache/return an AWS client object """
+        if type in self._clients:
+            return self._clients[type]
+
+        session = boto3.Session(
+            aws_access_key_id=self._access_key,
+            aws_secret_access_key=self._secret_key,
+            aws_session_token=self._session_token
+        )
+
+        self._clients[type] = session.client(
+            type, region_name=self._default_region)
+
+        return self._clients[type]
+
+    def get_available_db_version(self, engine='postgres'):
+        rds = self._get_aws_client('rds')
+        return rds.describe_db_engine_versions(Engine=engine)
+
+    def get_available_db_instance_class(self, engine='postgres',
+                                        engine_version='9.6'):
+        rds = self._get_aws_client('rds')
+        _instances = rds.describe_orderable_db_instance_options(
+            Engine=engine,
+            EngineVersion=engine_version)
+        _instances_list = _instances['OrderableDBInstanceOptions']
+        _marker = _instances['Marker'] if 'Marker' in _instances else None
+        while _marker:
+            _tmp_instances = rds.describe_orderable_db_instance_options(
+                Engine=engine,
+                EngineVersion=engine_version,
+                Marker=_marker)
+            _instances_list = [*_instances_list,
+                               *_tmp_instances['OrderableDBInstanceOptions']]
+            _marker = _tmp_instances['Marker'] if 'Marker'\
+                                                  in _tmp_instances else None
+
+        return _instances_list
+
+    def get_db_instance(self, instance_name):
+        rds = self._get_aws_client('rds')
+        return rds.describe_db_instances(
+            DBInstanceIdentifier=instance_name)
+
+    def validate_credentials(self):
+        client = self._get_aws_client('sts')
+        try:
+            identity = client.get_caller_identity()
+            return True, identity
+        except Exception as e:
+            return False, str(e)
+        finally:
+            self._clients.pop('sts')
+
+
+def verify_aws_credentials(data):
+    """Verify Credentials"""
+    session_token = data['secret']['aws_session_token'] if\
+        'aws_session_token' in data['secret'] else None
+
+    if 'aws' not in session:
+        session['aws'] = {}
+
+    if 'aws_rds_obj' not in session['aws'] or\
+            session['aws']['secret'] != data['secret']:
+        _rds = RDS(
+            access_key=data['secret']['aws_access_key'],
+            secret_key=data['secret']['aws_secret_access_key'],
+            session_token=session_token,
+            default_region=data['secret']['aws_region'])
+        status, identity = _rds.validate_credentials()
+        if status:
+            session['aws']['secret'] = data['secret']
+            session['aws']['aws_rds_obj'] = pickle.dumps(_rds, -1)
+        return status, identity
+
+    return True, None
+
+
+def clear_aws_session():
+    """Clear AWS Session"""
+    if 'aws' in session:
+        session.pop('aws')
+
+
+def get_aws_db_instances(eng_version):
+    """Get AWS DB Instances"""
+    if 'aws' not in session:
+        return False, 'Session has not created yet.'
+
+    if not eng_version or eng_version == '' or eng_version == 'undefined':
+        eng_version = '9.6.1'
+
+    rds_obj = pickle.loads(session['aws']['aws_rds_obj'])
+    res = rds_obj.get_available_db_instance_class(
+        engine_version=eng_version)
+    versions_set = set()
+    versions = []
+    for value in res:
+        versions_set.add(value['DBInstanceClass'])
+
+    for value in versions_set:
+        versions.append({
+            'label': value,
+            'value': value
+        })
+    return True, versions
+
+
+def get_aws_db_versions():
+    """Get AWS DB Versions"""
+
+    if 'aws' not in session:
+        return False, 'Session has not created yet.'
+
+    rds_obj = pickle.loads(session['aws']['aws_rds_obj'])
+    db_versions = rds_obj.get_available_db_version()
+    res = db_versions['DBEngineVersions']
+    versions = []
+    for value in res:
+        versions.append({
+            'label': value['DBEngineVersionDescription'],
+            'value': value['EngineVersion']
+        })
+    return True, versions
+
+
+def get_aws_regions():
+    """Get AWS DB Versions"""
+    clear_aws_session()
+    _session = Session()
+    res = _session.get_available_regions('rds')
+    regions = []
+    for value in res:
+        regions.append({
+            'label': value,
+            'value': value
+        })
+    return True, regions
diff --git a/web/pgadmin/model/__init__.py b/web/pgadmin/model/__init__.py
index 38a88992c..e4ce3ec30 100644
--- a/web/pgadmin/model/__init__.py
+++ b/web/pgadmin/model/__init__.py
@@ -30,7 +30,7 @@ import uuid
 #
 ##########################################################################
 
-SCHEMA_VERSION = 32
+SCHEMA_VERSION = 33
 
 ##########################################################################
 #
@@ -192,6 +192,7 @@ class Server(db.Model):
     tunnel_password = db.Column(db.String(64), nullable=True)
     shared = db.Column(db.Boolean(), nullable=False)
     kerberos_conn = db.Column(db.Boolean(), nullable=False, default=0)
+    cloud_status = db.Column(db.Integer(), nullable=False, default=0)
 
     @property
     def serialize(self):
@@ -325,6 +326,11 @@ class Process(db.Model):
     acknowledge = db.Column(db.String(), nullable=True)
     utility_pid = db.Column(db.Integer, nullable=False)
     process_state = db.Column(db.Integer, nullable=False)
+    server_id = db.Column(
+        db.Integer,
+        db.ForeignKey('server.id'),
+        nullable=True
+    )
 
 
 class Keys(db.Model):
diff --git a/web/pgadmin/static/js/SchemaView/MappedControl.jsx b/web/pgadmin/static/js/SchemaView/MappedControl.jsx
index c0ff2bb10..d787d0a16 100644
--- a/web/pgadmin/static/js/SchemaView/MappedControl.jsx
+++ b/web/pgadmin/static/js/SchemaView/MappedControl.jsx
@@ -167,7 +167,8 @@ MappedCellControlBase.propTypes = {
 const ALLOWED_PROPS_FIELD_COMMON = [
   'mode', 'value', 'readonly', 'disabled', 'hasError', 'id',
   'label', 'options', 'optionsLoaded', 'controlProps', 'schema', 'inputRef',
-  'visible', 'autoFocus', 'helpMessage', 'className', 'optionsReloadBasis'
+  'visible', 'autoFocus', 'helpMessage', 'className', 'optionsReloadBasis',
+  'orientation'
 ];
 
 const ALLOWED_PROPS_FIELD_FORM = [
diff --git a/web/pgadmin/static/js/Theme/index.jsx b/web/pgadmin/static/js/Theme/index.jsx
index 265690ab4..f526a6071 100644
--- a/web/pgadmin/static/js/Theme/index.jsx
+++ b/web/pgadmin/static/js/Theme/index.jsx
@@ -417,6 +417,10 @@ function getFinalTheme(baseTheme) {
               backgroundColor: 'abc',
             }
           }
+        },
+
+        label: {
+          textTransform: 'initial',
         }
       },
       MuiFormHelperText: {
diff --git a/web/pgadmin/static/js/api_instance.js b/web/pgadmin/static/js/api_instance.js
index 9aea50d18..a271f5a66 100644
--- a/web/pgadmin/static/js/api_instance.js
+++ b/web/pgadmin/static/js/api_instance.js
@@ -14,13 +14,14 @@ import axios from 'axios';
 /* Get the axios instance to call back end APIs.
 Do not import axios directly, instead use this */
 export default function getApiInstance(headers={}) {
-  return axios.create({
+  const api = axios.create({
     headers: {
       'Content-type': 'application/json',
       [pgAdmin.csrf_token_header]: pgAdmin.csrf_token,
       ...headers,
     }
   });
+  return api;
 }
 
 export function parseApiError(error) {
diff --git a/web/pgadmin/tools/backup/static/js/backup.js b/web/pgadmin/tools/backup/static/js/backup.js
index 7f9d28b74..373e92429 100644
--- a/web/pgadmin/tools/backup/static/js/backup.js
+++ b/web/pgadmin/tools/backup/static/js/backup.js
@@ -60,7 +60,7 @@ define([
         module: this,
         applies: ['tools'],
         callback: 'startBackupGlobal',
-        priority: 2,
+        priority: 3,
         label: gettext('Backup Globals...'),
         icon: 'fa fa-save',
         enable: menuUtils.menuEnabledServer,
@@ -72,7 +72,7 @@ define([
         module: this,
         applies: ['tools'],
         callback: 'startBackupServer',
-        priority: 2,
+        priority: 3,
         label: gettext('Backup Server...'),
         icon: 'fa fa-save',
         enable: menuUtils.menuEnabledServer,
@@ -85,7 +85,7 @@ define([
         node: 'server',
         applies: ['context'],
         callback: 'startBackupGlobal',
-        priority: 2,
+        priority: 3,
         label: gettext('Backup Globals...'),
         icon: 'fa fa-save',
         enable: menuUtils.menuEnabledServer,
@@ -98,7 +98,7 @@ define([
         node: 'server',
         applies: ['context'],
         callback: 'startBackupServer',
-        priority: 2,
+        priority: 3,
         label: gettext('Backup Server...'),
         icon: 'fa fa-save',
         enable: menuUtils.menuEnabledServer,
@@ -110,7 +110,7 @@ define([
         module: this,
         applies: ['tools'],
         callback: 'backupObjects',
-        priority: 2,
+        priority: 3,
         label: gettext('Backup...'),
         icon: 'fa fa-save',
         enable: supportedNodes.enabled.bind(
@@ -128,7 +128,7 @@ define([
           module: this,
           applies: ['context'],
           callback: 'backupObjects',
-          priority: 2,
+          priority: 3,
           label: gettext('Backup...'),
           icon: 'fa fa-save',
           enable: supportedNodes.enabled.bind(
diff --git a/web/webpack.config.js b/web/webpack.config.js
index 3181ecfe3..52fd8e087 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -549,6 +549,7 @@ module.exports = [{
             'pure|pgadmin.tools.search_objects',
             'pure|pgadmin.tools.erd_module',
             'pure|pgadmin.tools.psql_module',
+            'pure|pgadmin.misc.cloud',
           ],
         },
       },
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index 0430047c0..aad5bd183 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -220,6 +220,7 @@ var webpackShimConfig = {
     'pgadmin.file_utility': path.join(__dirname, './pgadmin/misc/file_manager/static/js/utility'),
     'pgadmin.help': path.join(__dirname, './pgadmin/help/static/js/help'),
     'pgadmin.misc.explain': path.join(__dirname, './pgadmin/misc/static/explain/js/explain'),
+    'pgadmin.misc.cloud': path.join(__dirname, './pgadmin/misc/cloud/static/js/cloud'),
     'pgadmin.node.cast': path.join(__dirname, './pgadmin/browser/server_groups/servers/databases/casts/static/js/cast'),
     'pgadmin.node.publication': path.join(__dirname, './pgadmin/browser/server_groups/servers/databases/publications/static/js/publication'),
     'pgadmin.node.subscription': path.join(__dirname, './pgadmin/browser/server_groups/servers/databases/subscriptions/static/js/subscription'),
